## mobilitydb 1.3.0~alpha

=== CMakeLists.txt ===
#-------------------------------------
# MobilityDB/MEOS Main CMake file
#-------------------------------------

# Minimum Cmake version supporting fixtures
cmake_minimum_required(VERSION 3.12)

# Disallow in-source builds
if(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})
  message(FATAL_ERROR "In-source builds not allowed.
  Please make a new directory (called a build directory) and run CMake from there.
  You may need to remove 'CMakeCache.txt' and 'CMakeFiles/'.")
endif()

# Set a default build type if none was specified
# https://www.kitware.com/cmake-and-the-default-build-type/
set(default_build_type "Release")
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to '${default_build_type}' as none was specified.")
  set(CMAKE_BUILD_TYPE "${default_build_type}" CACHE
      STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS
    "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

# Specify search path for CMake modules to be loaded
list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")
include(CheckSymbolExists)
include(CheckCXXSymbolExists)
include(CheckCSourceRuns)
include(CMakeDependentOption)

#-------------------------------------
# RPATH settings
# https://gitlab.kitware.com/cmake/community/-/wikis/doc/cmake/RPATH-handling
#-------------------------------------

# use, i.e. don't skip the full RPATH for the build tree
# set(CMAKE_SKIP_BUILD_RPATH FALSE)

# when building, don't use the install RPATH already
# (but later on when installing)
# set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)

# set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")

# add the automatically determined parts of the RPATH
# which point to directories outside the build tree to the install RPATH
# set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

# the RPATH to be used when installing, but only if it's not a system directory
# list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib" isSystemDir)
# if("${isSystemDir}" STREQUAL "-1")
    # set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
# endif("${isSystemDir}" STREQUAL "-1")

#-------------------------------------
# MobilityDB definitions
#-------------------------------------

# Windows build with MSVC

if(CMAKE_GENERATOR STREQUAL "Visual Studio 17 2022")
  message(STATUS "Setting options for Visual Studio")
  set(MSVC 1)
  # Disable native language support
  add_definitions(-DENABLE_NLS=0)
  # Disable warning C4996: 'strcpy': This function or variable may be unsafe.
  add_definitions(-D_CRT_SECURE_NO_WARNINGS=1)
endif()

# Option for including network points
option(MEOS
  "Set MEOS (default=OFF) to build the MEOS library instead of the MobilityDB
  PostgreSQL extension
  "
  OFF
)

# Option for including circular buffers
option(CBUFFER
  "Set ON|OFF (default=OFF) to include circular buffers
  "
  OFF
  )

# Option for including network points
option(NPOINT
  "Set ON|OFF (default=ON) to include network points
  "
  ON
  )

# Option for including geoposes
option(POSE
  "Set ON|OFF (default=OFF) to include geoposes
  "
  OFF
  )

# Option for including rigid geometries, which depend on geoposes
CMAKE_DEPENDENT_OPTION(RGEO
  "Set ON|OFF (default=OFF) to include rigid geometries
  "
  ON "POSE"
  OFF
  )

if(CBUFFER)
  message(STATUS "Including circular buffers")
  add_definitions(-DCBUFFER=1)
else()
  message(STATUS "Excluding circular buffers")
  add_definitions(-DCBUFFER=0)
endif()

if(NPOINT)
  message(STATUS "Including network points")
  add_definitions(-DNPOINT=1)
else()
  message(STATUS "Excluding network points")
  add_definitions(-DNPOINT=0)
endif()

if(POSE)
  message(STATUS "Including geoposes")
  add_definitions(-DPOSE=1)
else()
  message(STATUS "Excluding geoposes")
  add_definitions(-DPOSE=0)
endif()

if(RGEO)
  message(STATUS "Including rigid geometries")
  add_definitions(-DRGEO=1)
else()
  message(STATUS "Excluding rigid geometries")
  add_definitions(-DRGEO=0)
endif()

# Get the MobilityDB major/minor/micro versions from the text file
file(READ mobdb_version.txt ver)
string(REGEX MATCH "MOBILITYDB_MAJOR_VERSION=([0-9]+)" _ ${ver})
set(MOBILITYDB_MAJOR_VERSION ${CMAKE_MATCH_1})
string(REGEX MATCH "MOBILITYDB_MINOR_VERSION=([0-9]+)" _ ${ver})
set(MOBILITYDB_MINOR_VERSION ${CMAKE_MATCH_1})
string(REGEX MATCH "MOBILITYDB_MICRO_VERSION=([0-9]+)" _ ${ver})
set(MOBILITYDB_MICRO_VERSION ${CMAKE_MATCH_1})
string(REGEX MATCH "MOBILITYDB_MICRO_VERSION=[0-9]+(beta?[0-9]+)" _ ${ver})
set(PROJECT_VERSION_DEV ${CMAKE_MATCH_1})

# Set the project name and project version
project(MobilityDB VERSION ${MOBILITYDB_MAJOR_VERSION}.${MOBILITYDB_MINOR_VERSION}.${MOBILITYDB_MICRO_VERSION})
message(STATUS "Building MobilityDB version ${PROJECT_VERSION}")
# Enable testing, must follow project() call above
include(CTest)
# Make CTest run verbose for the output of the failed tests
set(CMAKE_CTEST_ARGUMENTS "--output-on-failure")
enable_testing()

set(MOBILITYDB_VERSION "${PROJECT_VERSION}")
set(MOBILITYDB_VERSION_STRING "${CMAKE_PROJECT_NAME} ${PROJECT_VERSION}${PROJECT_VERSION_DEV}")
add_definitions(-DMOBILITYDB_VERSION_STRING="${MOBILITYDB_VERSION_STRING}")
message(STATUS "MOBILITYDB_VERSION_STRING = '${MOBILITYDB_VERSION_STRING}'")

# Comment out code used for debugging purposes so it is not concerned by the coverage
if(CMAKE_BUILD_TYPE MATCHES Debug)
  message(STATUS "CMAKE_BUILD_TYPE = ${CMAKE_BUILD_TYPE}")
  add_definitions(-DDEBUG_BUILD)
endif()

#-------------------------------------
# Set compiler flags
#-------------------------------------

# Generate position-independent code (PIC)
include(CheckCCompilerFlag)
if(NOT WIN32)
  CHECK_C_COMPILER_FLAG("-fPIC" C_COMPILER_SUPPORTS_FPIC)
  if(C_COMPILER_SUPPORTS_FPIC)
    message(STATUS "Compiling into position-independent code (PIC)")
    add_definitions(-fPIC)
  endif()
endif()

# FFSL functions for finding the first (least significant) bit
check_symbol_exists(ffsl "string.h" HAS_FFSL)
if(NOT HAS_FFSL)
  message(STATUS "No ffsl functions provided")
  add_definitions(-DNO_FFSL)
endif()

# TODO
# Reentrant (_r) functions for POSIX hash table management (e.g. hsearch)
# check_symbol_exists("hsearch_r" "search.h" HAS_HSEARCH_R)
# if(NOT HAS_HSEARCH_R)
  # add_definitions(-DNO_HSEARCH_R)
# endif()

# Added to build on Windows to avoid the error 'M_PI': undeclared identifier
add_compile_definitions(_USE_MATH_DEFINES)

# Set default compile flags and code coverage for GCC
if(CMAKE_COMPILER_IS_GNUCC)
  # MobilityDB compiler flags
  add_definitions(-Wall -Wextra -std=gnu1x -Wunused-parameter -Wno-strict-aliasing)
  # -Wno-strict-aliasing was removed to access directly PostGIS points
  # See file tpoint_spatialfuncs.h
  # add_definitions(-Wall -Wextra -std=gnu1x -Wno-unused-parameter)
  # Code coverage
  if(WITH_COVERAGE)
    message(STATUS "Generating code coverage")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fprofile-arcs -ftest-coverage")
    set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -fprofile-arcs -ftest-coverage")
  endif()
endif()

# Set compiler optimizations for release
set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -O2")
# Disable compiler optimizations for debugging
set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -O0")

# Check machine architecture: big endian vs. little endian
# Needed for WKB support in MobilityDB and PostGIS (file postgis_config.h.in)
include(TestBigEndian)
TEST_BIG_ENDIAN(IS_BIG_ENDIAN)
if(IS_BIG_ENDIAN)
  message(STATUS "BIG_ENDIAN")
  add_definitions(-DMEOS_IS_BIG_ENDIAN=1)
  set(DEF_WORDS_BIGENDIAN ON)
else()
  message(STATUS "LITTLE_ENDIAN")
  add_definitions(-DMEOS_IS_BIG_ENDIAN=0)
  unset(DEF_WORDS_BIGENDIAN)
endif()

# check for needed Header files and functions
set(CMAKE_REQUIRED_DEFINITIONS -D_GNU_SOURCE)
check_symbol_exists(strchrnul "string.h" HAVE_STRCHRNUL)
unset(CMAKE_REQUIRED_DEFINITIONS)
check_symbol_exists(__get_cpuid "cpuid.h" HAVE__GET_CPUID)
check_c_source_runs("
#include <stdint.h>
int main() {
    uint64_t x = 1, r;
    __asm__ (\"popcntq %1, %0\" : \"=r\"(r) : \"r\"(x));
    return 0;
}" HAVE_X86_64_POPCNTQ)

#--------------------------------
# Other dependencies
#--------------------------------

# GEOS geometry library
find_package(GEOS REQUIRED)
include_directories(SYSTEM ${GEOS_INCLUDE_DIR})
math(EXPR POSTGIS_GEOS_VERSION "${GEOS_VERSION_MAJOR} * 10000 + ${GEOS_VERSION_MINOR} * 100 + ${GEOS_VERSION_MICRO}")
message(STATUS "POSTGIS_GEOS_VERSION: ${POSTGIS_GEOS_VERSION}")

# Proj reprojection library
find_package(PROJ REQUIRED)
include_directories(SYSTEM ${PROJ_INCLUDE_DIRS})
math(EXPR POSTGIS_PROJ_VERSION "${PROJ_VERSION_MAJOR} * 10 + ${PROJ_VERSION_MINOR}")
message(STATUS "POSTGIS_PROJ_VERSION: ${POSTGIS_PROJ_VERSION}")

# JSON-C library (used for MF-JSON input/output)
find_package(JSON-C REQUIRED)
include_directories(SYSTEM ${JSON-C_INCLUDE_DIRS})
message(STATUS "JSON-C_INCLUDE_DIRS: ${JSON-C_INCLUDE_DIRS}")
message(STATUS "JSON-C_LIBRARIES: ${JSON-C_LIBRARIES}")

# GSL (GNU Scientific Library) (used for skiplists)
find_package(GSL REQUIRED)
include_directories(SYSTEM ${GSL_INCLUDE_DIRS})
message(STATUS "GSL_VERSION: ${GSL_VERSION}")
add_definitions(-DGSL_VERSION_STRING="${GSL_VERSION}")

#----------------------------------------------
# Configure PostGIS with optional dependencies
#----------------------------------------------

find_package(GDAL QUIET)
if(GDAL_FOUND)
  message(STATUS "GDAL version '${GDAL_VERSION}' found")
else()
  message(STATUS "GDAL not found")
endif()

find_package(LibXml2)
if(LibXml2_FOUND)
  message(STATUS "LibXml2 version ${LIBXML2_VERSION_STRING} found")
else()
  message(STATUS "LibXml2 not found")
endif()

# find_package(Protobuf REQUIRED)
find_package(Protobuf QUIET)
if(Protobuf_FOUND)
  # Note that ${Protobuf_VERSION_STRING} is not set
  if (Protobuf_INCLUDE_DIR AND EXISTS "${Protobuf_INCLUDE_DIR}/google/protobuf/stubs/common.h")
      set(_Protobuf_VERSION_REGEX "^#define[ \t]+GOOGLE_PROTOBUF_VERSION[ \t]+([0-9]+).*$")
      file(STRINGS "${Protobuf_INCLUDE_DIR}/google/protobuf/stubs/common.h" Protobuf_VERSION REGEX "${_Protobuf_VERSION_REGEX}")
      if(Protobuf_VERSION MATCHES ${_Protobuf_VERSION_REGEX})
          set(Protobuf_VERSION "${CMAKE_MATCH_1}")
          math(EXPR Protobuf_VERSION_MAJOR "${Protobuf_VERSION} / 1000000")
          math(EXPR Protobuf_VERSION_MINOR "${Protobuf_VERSION} / 1000 % 1000")
          math(EXPR Protobuf_VERSION_PATCH "${Protobuf_VERSION} % 1000")
          set(Protobuf_VERSION_STRING "${Protobuf_VERSION_MAJOR}.${Protobuf_VERSION_MINOR}.${Protobuf_VERSION_PATCH}")
      endif()
      message(STATUS "Protobuf version '${Protobuf_VERSION_STRING}' found")
      unset(_Protobuf_VERSION_REGEX)
  endif()
else()
  message(STATUS "Protobuf not found")
endif()

find_package(Gettext QUIET)
if(GETTEXT_FOUND)
  message(STATUS "GETTEXT version '${GETTEXT_VERSION_STRING}' found")
else()
  message(STATUS "GETTEXT not found")
endif()

find_package(ICU QUIET)
if(ICU_FOUND)
  message(STATUS "ICU Version '${ICU_VERSION}' found")
else()
  message(STATUS "ICU NOT found")
endif()

#-------------------------------------
# Build either MobilityDB or MEOS
#-------------------------------------

if(MEOS)
  add_subdirectory(meos)
else()
  add_subdirectory(mobilitydb)
endif()

#-----------------------------------------------------------------------------
# Documentation
#-----------------------------------------------------------------------------

add_subdirectory(doc)
add_subdirectory(doxygen)

#-----------------------------------------------------------------------------
# The End
#-----------------------------------------------------------------------------

=== doc/CMakeLists.txt ===
#
# Copyright (c) 2021 Esteban Zimanyi
#
# Based on:
# https://github.com/pgRouting/pgrouting/blob/main/doc/CMakeLists.txt
#

#---------------------------------------------
# User's documentation options
#---------------------------------------------

option(DOC_ALL
  "Set ON|OFF (default=OFF) to build the user's documentation in all formats: HTML, PDF, and EPUB

  When OFF and want to build specific format, use the format code in capital letters:
  -D DOC_HTML=ON
  "
  OFF
)
option(DOC_HTML
  "Set ON|OFF (default=OFF) to build the user's documentation in HTML format" OFF)
option(DOC_PDF
  "Set ON|OFF (default=OFF) to build the user's documentation in PDF format" OFF)
option(DOC_EPUB
  "Set ON|OFF (default=OFF) to build the user's documentation in EPUB format" OFF)

# Defining the user's documentation format options
foreach(format DOC_HTML DOC_PDF DOC_EPUB)
  string(TOUPPER ${format} opt)
  if(${opt} OR DOC_ALL)
    list(APPEND PROJECT_DOC_TARGETS ${opt})
    set(${opt} ON)
  endif()
endforeach()

message(STATUS "PROJECT_DOC_TARGETS = ${PROJECT_DOC_TARGETS}")

#---------------------------------------------
# Available Languages
# English is always built
#---------------------------------------------

set(PROJECT_SUPPORTED_LANGUAGES "es")
set(PROJECT_SUPPORTED_LANGUAGES_STRING "Spanish")
set(PROJECT_ENGLISH "en")
set(PROJECT_ENGLISH_STRING "English")

#---------------------------------------------
# Language options
#---------------------------------------------

option(LANG_ALL
  "Set ON|OFF (default=OFF) to build all the supported languages:
  Main language will always be built:
  ${PROJECT_ENGLISH_STRING}
  Optional languages:
  ${PROJECT_SUPPORTED_LANGUAGES_STRING}

  When OFF and want to build specific optional language, use the language code in capital letters:
  -D ES=ON
  "
  OFF
)

# Defining the available language options
foreach(lang ${PROJECT_SUPPORTED_LANGUAGES})
  list(FIND PROJECT_SUPPORTED_LANGUAGES ${lang} idx)
  list(GET PROJECT_SUPPORTED_LANGUAGES_STRING ${idx} lang_str)
  string(TOUPPER ${lang} val)
  option(${val}
    "Set ON|OFF (default=OFF) build the ${lang_str} user's documentation" OFF)
endforeach()

# Determining the language to be build. English is always built.
list(APPEND PROJECT_BUILD_LANGUAGES ${PROJECT_ENGLISH})
list(APPEND PROJECT_BUILD_LANGUAGES_STRING ${PROJECT_ENGLISH_STRING})
foreach(lang ${PROJECT_SUPPORTED_LANGUAGES})
  string(TOUPPER ${lang} opt)
  if(${opt} OR LANG_ALL)
    list(FIND PROJECT_SUPPORTED_LANGUAGES lang idx)
    list(GET PROJECT_SUPPORTED_LANGUAGES_STRING idx lang_str)
    list(APPEND PROJECT_BUILD_LANGUAGES ${lang})
    list(APPEND PROJECT_BUILD_LANGUAGES_STRING ${lang_str})
  endif()
endforeach()
message(STATUS "PROJECT_BUILD_LANGUAGES = ${PROJECT_BUILD_LANGUAGES}")
message(STATUS "PROJECT_BUILD_LANGUAGES_STRING = ${PROJECT_BUILD_LANGUAGES_STRING}")

#---------------------------------------------
# Processing
#---------------------------------------------

if(DOC_HTML OR DOC_PDF OR DOC_EPUB OR DOC_ALL)
  message(STATUS "Build the user's documentation.")
  # Required package for generating the user's documentation in any format
  find_package(DocBook REQUIRED)
  # Required package for validating the XML files of the user's documentation with xmllint
  find_package(LibXml2 REQUIRED)

  # Add an empty main doc target that will be dependent on the main format targets
  add_custom_target(doc
    COMMENT "Generating the user's documentation" VERBATIM
  )

  # Optional packages for generating the user's documentation in
  # HTML, PDF, or EPUB depending on the selected options

  # Set the message level
  # - to WARNING for finding at least one target when building all formats
  # - to FATAL_ERROR when the requested target cannot be built
  if(DOC_ALL)
    set(msg_level "WARNING")
  else()
    set(msg_level "FATAL_ERROR")
  endif()

  # Required packages for generating the user's documentation in HTML format
  if(DOC_HTML)
    find_package(LibXslt)
    if(NOT LIBXSLT_FOUND)
      message(${msg_level} "No package found for generating the user's documentation in HTML format")
    endif()
  endif()

  # Required packages for generating the user's documentation in PDF format
  if(DOC_PDF)
    find_package(DBLATEX)
    if(NOT DBLATEX_FOUND)
      message(${msg_level} "No package found for generating the user's documentation in PDF format")
    endif()
  endif()

  # Required packages for generating the user's documentation in EPUB format
  if(DOC_EPUB)
    find_package(LibXslt)
    find_package(DBTOEPUB)
    if(NOT LIBXSLT_FOUND OR NOT DBTOEPUB_FOUND)
      message(${msg_level} "No package found for generating the user's documentation in EPUB format")
    endif()
  endif()

  # When building all formats verify that at least one format will be produced
  if(DOC_ALL)
    if(NOT LIBXSLT_FOUND AND NOT DBLATEX_FOUND AND NOT DBTOEPUB_FOUND)
      message(FATAL_ERROR "No package found for generating the user's documentation")
    endif()
  endif()

  # Function that validates the XML files of the user's documentation
  function(validate_xml_file file lang)
    message(STATUS "Validating the XML files of the ${lang_str} user's documentation")
    execute_process(
      COMMAND ${LIBXML2_XMLLINT_EXECUTABLE} --valid --noent --noout ${file}
      RESULT_VARIABLE STATUS
      ERROR_QUIET
    )
    if(STATUS AND NOT STATUS EQUAL 0)
      message(FATAL_ERROR "The XML files are not valid. Please run xmllint to validate them.")
    endif()
    return()
  endfunction(validate_xml_file)

  # Validate the XML files of the user's documentation for all build languages
  foreach (lang ${PROJECT_BUILD_LANGUAGES})
    list(FIND PROJECT_BUILD_LANGUAGES "${lang}" idx)
    list(GET PROJECT_BUILD_LANGUAGES_STRING "${idx}" lang_str)
    if("${lang}" STREQUAL "en")
      validate_xml_file(${CMAKE_CURRENT_SOURCE_DIR}/mobilitydb-manual.xml lang lang_str)
    else()
      validate_xml_file(${CMAKE_CURRENT_SOURCE_DIR}/${lang}/mobilitydb-manual.xml lang lang_str)
    endif()
  endforeach()

  # Generating the user's documentation in HTML format
  if(LIBXSLT_FOUND)
    # Add an empty main html target
    add_custom_target(doc_html
      COMMENT "Generating the user's documentation in HTML format" VERBATIM
    )
    # Make the main doc target dependent on the main html target
    if(DOC_ALL OR DOC_HTML)
      add_dependencies(doc doc_html)
    endif()
    # Add target copying the image directory and make the main html target dependent on it
    add_custom_target(doc_html_img
      COMMAND ${CMAKE_COMMAND} -E copy_directory
         ${CMAKE_CURRENT_SOURCE_DIR}/images ${CMAKE_CURRENT_BINARY_DIR}/images
      COMMENT "Copying the image files of the user's documentation" VERBATIM
    )
    add_dependencies(doc_html doc_html_img)
    # Loop for all build languages
    foreach (lang ${PROJECT_BUILD_LANGUAGES})
      # Set subdirectory variable for all languages excepted English
      if("${lang}" STREQUAL "en")
        set(locale "")
      else()
        set(locale "/${lang}")
      endif()
      # Get the message string for every language
      list(FIND PROJECT_BUILD_LANGUAGES "${lang}" idx)
      list(GET PROJECT_BUILD_LANGUAGES_STRING "${idx}" lang_str)
      # Add html target for every language and make the main html target dependent on it
      add_custom_target(doc_html_${lang}
        ${LIBXSLT_XSLTPROC_EXECUTABLE} --output ${CMAKE_CURRENT_BINARY_DIR}${locale}/index.html
          # Include the customized docbook.css
          --stringparam html.stylesheet docbook.css
          # Make section numbers to include the chapter number. This assumes chapter numbering is turned on
          --stringparam section.autolabel 1 --stringparam section.label.includes.component.label 1
          # Generated text for chapters, sections, figures... is only the number and not the tile
          --stringparam xref.with.number.and.title 0
          # Placement for the legend for figures is after
          --stringparam formal.title.placement "figure after table after"
          # Allow controlling individual cell borders
          --stringparam table.borders.with.css 1
          --xinclude ${DOCBOOK_XSL}/html/chunk.xsl ${CMAKE_CURRENT_SOURCE_DIR}${locale}/mobilitydb-manual.xml
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        COMMENT "Generating the ${lang_str} user's documentation in HTML format" VERBATIM
      )
      add_dependencies(doc_html doc_html_${lang})
      # Add target creating the subdirectory for every language distinct than English
      # and make the html target for the language dependent on it
      if(NOT "${lang}" STREQUAL "en")
        add_custom_target(doc_html_${lang}_dir
          ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_BINARY_DIR}${locale}
          COMMENT "Creating directory ${CMAKE_CURRENT_BINARY_DIR}${locale}" VERBATIM
        )
        add_dependencies(doc_html_${lang} doc_html_${lang}_dir)
      endif()
      # Add target copying the docbook.css and make the html target for each language dependent on it
      add_custom_target(doc_html_${lang}_css
        COMMAND ${CMAKE_COMMAND} -E copy
           ${CMAKE_CURRENT_SOURCE_DIR}/docbook.css ${CMAKE_CURRENT_BINARY_DIR}${locale}
        COMMENT "Copying the docbook.css file in the directory ${CMAKE_CURRENT_BINARY_DIR}${locale}" VERBATIM
      )
      if(NOT "${lang}" STREQUAL "en")
        add_dependencies(doc_html_${lang}_css doc_html_${lang}_dir)
      endif()
      add_dependencies(doc_html_${lang} doc_html_${lang}_css)
    endforeach()
 endif()

  # Generating the user's documentation in PDF format
  if(DBLATEX_FOUND)
    # Add an empty main pdf target
    add_custom_target(doc_pdf
      COMMENT "Generating the user's documentation in PDF format" VERBATIM
    )
    # Make the main doc target dependent on the main pdf target
    if(DOC_ALL OR DOC_PDF)
      add_dependencies(doc doc_pdf)
    endif()
    # Loop for all build languages
    foreach (lang ${PROJECT_BUILD_LANGUAGES})
      # Set subdirectory variable for all languages excepted English
      if("${lang}" STREQUAL "en")
        set(locale "")
      else()
        set(locale "/${lang}")
      endif()
      # Get the message string for every language
      list(FIND PROJECT_BUILD_LANGUAGES "${lang}" idx)
      list(GET PROJECT_BUILD_LANGUAGES_STRING "${idx}" lang_str)
      # Add pdf target for every language and make the main pdf target dependent on it
      add_custom_target(doc_pdf_${lang}
        ${DBLATEX_COMMAND} -s ${CMAKE_CURRENT_SOURCE_DIR}${locale}/texstyle.sty
          ${CMAKE_CURRENT_SOURCE_DIR}${locale}/mobilitydb-manual.xml
          -o ${CMAKE_CURRENT_BINARY_DIR}${locale}/mobilitydb-manual.pdf
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        COMMENT "Generating the ${lang_str} user's documentation in PDF format" VERBATIM
      )
      add_dependencies(doc_pdf doc_pdf_${lang})
      # Add target creating the subdirectory for every language distinct than English
      # and make the pdf target for the language dependent on it
      if(NOT "${lang}" STREQUAL "en")
        add_custom_target(doc_pdf_${lang}_dir
          ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_BINARY_DIR}${locale}
          COMMENT "Creating directory ${CMAKE_CURRENT_BINARY_DIR}${locale}" VERBATIM
        )
        add_dependencies(doc_pdf_${lang} doc_pdf_${lang}_dir)
      endif()
    endforeach()
  endif()

  # Generating the user's documentation in EPUB format
  if(DBTOEPUB_FOUND)
    # Set the ${DOCBOOK_XSL} variable in the epub.xsl file
    configure_file(epub.xsl ${CMAKE_CURRENT_BINARY_DIR}/epub.xsl)
    # Add an empty main epub target
    add_custom_target(doc_epub
        COMMENT "Generating the user's documentation in EPUB format" VERBATIM
    )
    # Make the main doc target dependent on the main epub target
    if(DOC_ALL OR DOC_EPUB)
      add_dependencies(doc doc_epub)
    endif()
    # Loop for all build languages
    foreach (lang ${PROJECT_BUILD_LANGUAGES})

=== doxygen/CMakeLists.txt ===
#
# Based on:
# https://majewsky.wordpress.com/2010/08/14/tip-of-the-day-cmake-and-doxygen/
#

option(DOC_DEV
  "Set ON|OFF (default=OFF) to build the developer's documentation" OFF)

if(DOC_DEV)
  message(STATUS "Build the developer's documentation.")
  find_package(Doxygen ${DOXYGEN_MINIMUM_VERSION})

  if(DOXYGEN_FOUND)
    configure_file(${CMAKE_SOURCE_DIR}/doxygen/Doxyfile
      ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
    add_custom_target(doc_dev
      ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
      WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
      COMMENT "Generating the developer's documentation with Doxygen" VERBATIM
    )
  endif()

endif()

=== meos/CMakeLists.txt ===
#-------------------------------------
# MEOS CMake file
#-------------------------------------

message(STATUS "-------------------------")
message(STATUS "Building the MEOS library")
message(STATUS "-------------------------")

# Set MEOS option for building the MEOS library
set(MEOS ON)

# Enable code specific to MEOS, typically user-oriented wrapper functions
# hiding internal implementation details from the API. Such functions are
# not used in the MobilityDB PostgreSQL extension.
add_definitions(-DMEOS=1)

# Set the version and name of the MEOS library
set(MEOS_LIB_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}")
set(MEOS_LIB_NAME "meos")
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})

# Set the location of the directory of the time zone database
add_definitions(-DSYSTEMTZDIR="/usr/share/zoneinfo")
message(STATUS "Directory of the time zone database: /usr/share/zoneinfo")

# Option to build MEOS as a shared or static library
option(BUILD_SHARED_LIBS
  "Set BUILD_SHARED_LIBS (default=ON) to build MEOS as a shared library"
  ON
)

# Option to show debug messages for analyzing the expandable data structures
option(DEBUG_EXPAND
  "Set DEBUG_EXPAND (default=OFF) to show debug messages for analyzing the
  expandable data structures
  "
  OFF
)

if(DEBUG_EXPAND)
  add_definitions(-DDEBUG_EXPAND=1)
  message(STATUS "Showing debug messages for expandable data structures")
endif()

#-----------------------------------------------------------------------------
# Install directories
#-----------------------------------------------------------------------------

include(GNUInstallDirs)

#-----------------------------------------
# Set default PostgreSQL Version for MEOS
#-----------------------------------------

set(POSTGRESQL_VERSION_STRING "PostgreSQL 14.2")
set(POSTGRESQL_VERSION_NUMBER "140200")
set(POSTGRESQL_VERSION_MAJOR "14")
set(POSTGRESQL_VERSION_MINOR "2")

# MobilityDB definitions for PostgreSQL version-dependent code
add_definitions(-DPOSTGRESQL_VERSION_STRING="${POSTGRESQL_VERSION_STRING}")
add_definitions(-DPOSTGRESQL_VERSION_NUMBER=${POSTGRESQL_VERSION_NUMBER})

#--------------------------------------
# Set default PostGIS Version for MEOS
#--------------------------------------

set(POSTGIS_VERSION_STRING "PostGIS 3.5.0")
set(POSTGIS_VERSION_NUMBER "30500")
set(POSTGIS_VERSION_MAJOR "3")
set(POSTGIS_VERSION_MINOR "5")
set(POSTGIS_VERSION_MICRO "0")
set(POSTGIS_VERSION "3.5.0")

set(SRID_MAX "999999")
set(SRID_USR_MAX "998999")

# POSTGIS_PGSQL_VERSION is used in PostGIS for PostgreSQL version-dependent code
# Note that we cannot add ${POSTGRESQL_VERSION_MINOR} since, e.g., for version
# 13.13 it will yield 143 which is not intended
math(EXPR POSTGIS_PGSQL_VERSION "${POSTGRESQL_VERSION_MAJOR} * 10")
message(STATUS "POSTGIS_PGSQL_VERSION=${POSTGIS_PGSQL_VERSION}")

add_definitions(-DPOSTGIS_VERSION_STRING="${POSTGIS_VERSION_STRING}")
add_definitions(-DPOSTGIS_VERSION_NUMBER=${POSTGIS_VERSION_NUMBER})
add_definitions(-DPOSTGIS_PGSQL_VERSION=${POSTGIS_PGSQL_VERSION})

#--------------------------------
# MobilityDB directories
#--------------------------------

# PostGIS
configure_file(../postgis/liblwgeom/liblwgeom.h.in ../postgis/liblwgeom/liblwgeom.h)
configure_file(../postgis/postgis_config.h.in ../postgis/postgis_config.h)
include_directories(SYSTEM "${CMAKE_SOURCE_DIR}/postgis/liblwgeom")
include_directories(SYSTEM "${CMAKE_SOURCE_DIR}/postgis")
include_directories(SYSTEM "${CMAKE_BINARY_DIR}/postgis/liblwgeom")
include_directories(SYSTEM "${CMAKE_BINARY_DIR}/postgis")
add_subdirectory("${CMAKE_SOURCE_DIR}/postgis" "postgis")

# PostgreSQL
configure_file(postgres/pg_config.h.in postgres/pg_config.h)
include_directories("postgres")
include_directories("${CMAKE_BINARY_DIR}/meos/postgres")
add_subdirectory("postgres")

# MEOS
include_directories("include")
add_subdirectory("src")

# Must be after add_library
if(CMAKE_GENERATOR STREQUAL "Unix Makefiles" OR CMAKE_GENERATOR STREQUAL "Ninja")
  # Disable all warnings on embeded code from PostgreSQL and PostGIS
  target_compile_options(liblwgeom PRIVATE "-w")
  target_compile_options(ryu PRIVATE "-w")
  target_compile_options(timezone PRIVATE "-w")
  target_compile_options(utils PRIVATE "-w")
elseif(CMAKE_GENERATOR STREQUAL "Visual Studio 17 2022")
  # Disable all warnings on embedded code from PostgreSQL and PostGIS
  target_compile_options(liblwgeom PRIVATE "/W0")
  target_compile_options(ryu PRIVATE "/W0")
  target_compile_options(timezone PRIVATE "/W0")
  target_compile_options(utils PRIVATE "/W0")
  # Enable all warnings on MEOS and MobilityDB
  target_compile_options(temporal PRIVATE "/W4")
  target_compile_options(geo PRIVATE "/W4")
  if(CBUFFER)
    target_compile_options(cbuffer PRIVATE "/W4")
  endif()
  if(NPOINT)
    target_compile_options(npoint PRIVATE "/W4")
  endif()
  if(POSE)
    target_compile_options(pose PRIVATE "/W4")
  endif()
  if(RGEO)
    target_compile_options(rgeo PRIVATE "/W4")
  endif()
endif()

#--------------------------------
# Build MEOS library
#--------------------------------

# Customize the meos.in.h and meos_internal.in.h files for external include with MEOS library
# Read files
file(READ "${CMAKE_SOURCE_DIR}/meos/include/meos.h" MEOS_H)
file(READ "${CMAKE_SOURCE_DIR}/meos/include/meos_internal.h" MEOS_INTERNAL_H)
file(READ "${CMAKE_SOURCE_DIR}/meos/include/meos_geo.h" MEOS_GEO_H)
file(READ "${CMAKE_SOURCE_DIR}/meos/include/postgres_ext_defs.in.h" POSTGRES_EXT_DEFS_IN_H)
file(READ "${CMAKE_SOURCE_DIR}/meos/include/postgis_ext_defs.in.h" POSTGIS_EXT_DEFS_IN_H)
# Generate meos_export.h
string(REGEX REPLACE "#if MEOS\n#include \"postgres_int_defs.h\"\n#else\n#include <postgres.h>\n#include <utils/date.h>\n#include <utils/timestamp.h>\n#endif" "${POSTGRES_EXT_DEFS_IN_H}" MEOS_EXP_H "${MEOS_H}")
file(WRITE "${CMAKE_BINARY_DIR}/meos_export.h" "${MEOS_EXP_H}")
# Generate meos_internal_export.h
string(REGEX REPLACE "#include \"temporal/meos_catalog.h\"" "#include \"meos_catalog.h\"" MEOS_INTERNAL_EXP_H "${MEOS_INTERNAL_H}")
file(WRITE "${CMAKE_BINARY_DIR}/meos_internal_export.h" "${MEOS_INTERNAL_EXP_H}")
# Generate meos_geo_export.h
string(REGEX REPLACE "#include <liblwgeom.h>" "${POSTGIS_EXT_DEFS_IN_H}" MEOS_GEO_EXP_H "${MEOS_GEO_H}")
file(WRITE "${CMAKE_BINARY_DIR}/meos_geo_export.h" "${MEOS_GEO_EXP_H}")

# MEOS
set(PROJECT_OBJECTS "$<TARGET_OBJECTS:temporal>")
set(PROJECT_OBJECTS ${PROJECT_OBJECTS} "$<TARGET_OBJECTS:geo>")
if(CBUFFER)
  message(STATUS "Including circular buffers")
  set(PROJECT_OBJECTS ${PROJECT_OBJECTS} "$<TARGET_OBJECTS:cbuffer>")
endif()
if(NPOINT)
  message(STATUS "Including network points")
  set(PROJECT_OBJECTS ${PROJECT_OBJECTS} "$<TARGET_OBJECTS:npoint>")
endif()
if(POSE)
  message(STATUS "Including geoposes")
  set(PROJECT_OBJECTS ${PROJECT_OBJECTS} "$<TARGET_OBJECTS:pose>")
endif()
if(RGEO)
  message(STATUS "Including rigid geometries")
  set(PROJECT_OBJECTS ${PROJECT_OBJECTS} "$<TARGET_OBJECTS:rgeo>")
endif()

# PostgreSQL
set(PROJECT_OBJECTS ${PROJECT_OBJECTS} "$<TARGET_OBJECTS:common>")
set(PROJECT_OBJECTS ${PROJECT_OBJECTS} "$<TARGET_OBJECTS:port>")
set(PROJECT_OBJECTS ${PROJECT_OBJECTS} "$<TARGET_OBJECTS:timezone>")
set(PROJECT_OBJECTS ${PROJECT_OBJECTS} "$<TARGET_OBJECTS:utils>")

# Build the library: PostGIS
set(PROJECT_OBJECTS ${PROJECT_OBJECTS} "$<TARGET_OBJECTS:liblwgeom>")
set(PROJECT_OBJECTS ${PROJECT_OBJECTS} "$<TARGET_OBJECTS:ryu>")

# Build the library: All
add_library(${MEOS_LIB_NAME} ${PROJECT_OBJECTS})
if(APPLE)
  set_target_properties(${MEOS_LIB_NAME} PROPERTIES
    LINK_FLAGS "-Wl,-undefined,dynamic_lookup")
endif()

#--------------------------------
# Specify libraries to link
#--------------------------------

target_link_libraries(${MEOS_LIB_NAME} ${JSON-C_LIBRARIES})
target_link_libraries(${MEOS_LIB_NAME} ${GEOS_LIBRARY})
target_link_libraries(${MEOS_LIB_NAME} ${PROJ_LIBRARIES})
target_link_libraries(${MEOS_LIB_NAME} ${GSL_LIBRARY})
target_link_libraries(${MEOS_LIB_NAME} ${GSL_CBLAS_LIBRARY})

#--------------------------------
# Belongs to MEOS
#--------------------------------

install(FILES "${CMAKE_BINARY_DIR}/meos_export.h"
  DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
  RENAME "meos.h")
install(
  FILES "${CMAKE_BINARY_DIR}/meos_internal_export.h"
  DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
  RENAME "meos_internal.h")
install(
  FILES "${CMAKE_BINARY_DIR}/meos_geo_export.h"
  DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
  RENAME "meos_geo.h")
install(
  FILES "${CMAKE_SOURCE_DIR}/meos/include/meos_internal_geo.h"
  DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")
install(
  FILES "${CMAKE_SOURCE_DIR}/meos/src/geo/spatial_ref_sys.csv"
  DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}")

if(CBUFFER)
  install(
    FILES "${CMAKE_SOURCE_DIR}/meos/include/meos_cbuffer.h"
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")
endif()
if(NPOINT)
  install(
    FILES "${CMAKE_SOURCE_DIR}/meos/include/meos_npoint.h"
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")
  install(
    FILES "${CMAKE_SOURCE_DIR}/meos/examples/data/ways.csv"
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}")
  install(
    FILES "${CMAKE_SOURCE_DIR}/meos/examples/data/ways1000.csv"
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}")
endif()
if(POSE)
  install(
    FILES "${CMAKE_SOURCE_DIR}/meos/include/meos_pose.h"
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")
endif()
if(RGEO)
  install(
    FILES "${CMAKE_SOURCE_DIR}/meos/include/meos_rgeo.h"
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")
endif()

install(
  FILES "${CMAKE_SOURCE_DIR}/meos/include/temporal/meos_catalog.h"
  DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")
install(TARGETS ${MEOS_LIB_NAME} DESTINATION "${CMAKE_INSTALL_LIBDIR}")
message(STATUS "Building MEOS:")
message(STATUS "  Install prefix: '${CMAKE_INSTALL_PREFIX}'")
message(STATUS "  Library file: '${CMAKE_INSTALL_LIBDIR}'")
message(STATUS "  Include file: '${CMAKE_INSTALL_INCLUDEDIR}'")

#-----------------------------------------------------------------------------
# Configure pkg-config file meos.pc
#-----------------------------------------------------------------------------

# Consider CMAKE_INSTALL_PREFIX with spaces
string(REPLACE " " "\\ " prefix ${CMAKE_INSTALL_PREFIX})
set(exec_prefix "$\{prefix\}")
if(IS_ABSOLUTE "${CMAKE_INSTALL_INCLUDEDIR}")
  set(includedir "${CMAKE_INSTALL_INCLUDEDIR}")
else()
  set(includedir "$\{prefix\}/${CMAKE_INSTALL_INCLUDEDIR}")
endif()
if(IS_ABSOLUTE "${CMAKE_INSTALL_LIBDIR}")
  set(libdir "${CMAKE_INSTALL_LIBDIR}")
else()
  set(libdir "$\{exec_prefix\}/${CMAKE_INSTALL_LIBDIR}")
endif()
set(VERSION ${MEOS_LIB_VERSION})

configure_file(
  ${CMAKE_SOURCE_DIR}/tools/meos.pc.in
  ${CMAKE_BINARY_DIR}/meos.pc
  @ONLY)

install(
  FILES ${CMAKE_BINARY_DIR}/meos.pc
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

#-----------------------------------------------------------------------------
# The End
#-----------------------------------------------------------------------------

=== mobilitydb/CMakeLists.txt ===
#-------------------------------------
# MobilityDB CMake file
#-------------------------------------

message(STATUS "-------------------")
message(STATUS "Building MobilityDB")
message(STATUS "-------------------")

# Disable code specific to MEOS which is not used in the MobilityDB PostgreSQL
# extension.
add_definitions(-DMEOS=0)

# Set the version and name of the library
set(MOBILITYDB_LIB_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}")
set(MOBILITYDB_LIB_NAME "${CMAKE_PROJECT_NAME}-${MOBILITYDB_LIB_VERSION}")
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})

# Set the name of the PostgreSQL extension
string(TOLOWER ${CMAKE_PROJECT_NAME} MOBILITYDB_LOWERCASE_NAME)
set(MOBILITYDB_EXTENSION_FILE "${MOBILITYDB_LOWERCASE_NAME}--${PROJECT_VERSION}.sql")
set(MOBILITYDB_DATAGEN_EXTENSION_FILE "${MOBILITYDB_LOWERCASE_NAME}_datagen--${PROJECT_VERSION}.sql")

# Comment out code used for debugging purposes so it is not concerned by the coverage
if(CMAKE_BUILD_TYPE MATCHES Debug)
  message(STATUS "CMAKE_BUILD_TYPE = ${CMAKE_BUILD_TYPE}")
  add_definitions(-DDEBUG_BUILD=1)
else()
  add_definitions(-DDEBUG_BUILD=0)
endif()

# Option to show debug messages for analyzing the selectivity estimation
option(DEBUG_SELECTIVITY
  "Set DEBUG_SELECTIVITY (default=OFF) to show debug messages for analyzing the
  selectivity estimation
  "
  OFF
)

if(DEBUG_SELECTIVITY)
  add_definitions(-DDEBUG_SELECTIVITY=1)
  message(STATUS "Showing debug messages for selectivity estimation")
endif()

#-------------------------------------
# Get PostgreSQL Version
#-------------------------------------

# Find PostgreSQL
set(PG_MIN_MAJOR_VERSION "13")
set(PG_MAX_MAJOR_VERSION "14")
find_package(POSTGRESQL ${PG_MIN_MAJOR_VERSION} REQUIRED)
if(NOT POSTGRES_VERSION VERSION_LESS PG_MAX_MAJOR_VERSION)
  message(FATAL_ERROR "Not supporting PostgreSQL ${POSTGRESQL_VERSION}")
endif()

include_directories(SYSTEM ${POSTGRESQL_INCLUDE_DIR})
if(WIN32)
  include_directories(SYSTEM ${POSTGRESQL_INCLUDE_DIR}/port/win32)
  if(MSVC)
    include_directories(SYSTEM ${POSTGRESQL_INCLUDE_DIR}/port/win32_msvc/)
  endif()
  link_directories(${POSTGRESQL_LIBRARIES})
  link_libraries(postgres)
endif()

# MobilityDB definitions for PostgreSQL version-dependent code
add_definitions(-DPOSTGRESQL_VERSION_STRING="${POSTGRESQL_VERSION_STRING}")
add_definitions(-DPOSTGRESQL_VERSION_NUMBER=${POSTGRESQL_VERSION_NUMBER})

#-------------------------------------
# Get PostGIS Version
#-------------------------------------

find_package(POSTGIS REQUIRED)

# POSTGIS_PGSQL_VERSION is used in PostGIS for PostgreSQL version-dependent code
# Note that we cannot add ${POSTGRESQL_VERSION_MINOR} since, e.g., for version
# 13.13 it will yield 143 which is not intended
math(EXPR POSTGIS_PGSQL_VERSION "${POSTGRESQL_VERSION_MAJOR} * 10")
message(STATUS "POSTGIS_PGSQL_VERSION=${POSTGIS_PGSQL_VERSION}")

add_definitions(-DPOSTGIS_VERSION_STRING="${POSTGIS_VERSION_STR}")
add_definitions(-DPOSTGIS_VERSION_NUMBER=${POSTGIS_VERSION_NUMBER})
add_definitions(-DPOSTGIS_PGSQL_VERSION=${POSTGIS_PGSQL_VERSION})

#--------------------------------
# MobilityDB directories
#--------------------------------

set(SRID_MAX "999999")
set(SRID_USR_MAX "998999")

# Embed PostGIS
configure_file(../postgis/liblwgeom/liblwgeom.h.in ../postgis/liblwgeom/liblwgeom.h)
configure_file(../postgis/postgis_config.h.in ../postgis/postgis_config.h)
include_directories(SYSTEM "${CMAKE_SOURCE_DIR}/postgis/liblwgeom")
include_directories(SYSTEM "${CMAKE_SOURCE_DIR}/postgis/libpgcommon")
include_directories(SYSTEM "${CMAKE_SOURCE_DIR}/postgis")
include_directories(SYSTEM "${CMAKE_BINARY_DIR}/postgis/liblwgeom")
include_directories(SYSTEM "${CMAKE_BINARY_DIR}/postgis")
add_subdirectory("${CMAKE_SOURCE_DIR}/postgis" "postgis")

# MEOS
include_directories("${CMAKE_SOURCE_DIR}/meos/include")
add_subdirectory("${CMAKE_SOURCE_DIR}/meos/src" "meos_src")

# MobilityDB
include_directories("pg_include")
add_subdirectory("src")

# Must be after add_library
if(CMAKE_GENERATOR STREQUAL "Unix Makefiles" OR CMAKE_GENERATOR STREQUAL "Ninja")
  # Disable all warnings on embeded code from PostgreSQL and PostGIS
  target_compile_options(liblwgeom PRIVATE "-w")
  target_compile_options(libpgcommon PRIVATE "-w")
  target_compile_options(ryu PRIVATE "-w")
elseif(CMAKE_GENERATOR STREQUAL "Visual Studio 17 2022")
  # Disable all warnings on embeded code from PostgreSQL and PostGIS
  target_compile_options(liblwgeom PRIVATE "/W0")
  target_compile_options(libpgcommon PRIVATE "/W0")
  target_compile_options(ryu PRIVATE "/W0")
  # Enable all warnings on MEOS and MobilityDB
  target_compile_options(temporal PRIVATE "/W4")
  target_compile_options(geo PRIVATE "/W4")
  target_compile_options(pg_temporal PRIVATE "/W4")
  target_compile_options(pg_geo PRIVATE "/W4")
  if(CBUFFER)
    target_compile_options(cbuffer PRIVATE "/W4")
    target_compile_options(pg_cbuffer PRIVATE "/W4")
  endif()
  if(NPOINT)
    target_compile_options(npoint PRIVATE "/W4")
    target_compile_options(pg_npoint PRIVATE "/W4")
  endif()
  if(POSE)
    target_compile_options(pose PRIVATE "/W4")
    target_compile_options(pg_pose PRIVATE "/W4")
  endif()
  if(RGEO)
    target_compile_options(rgeo PRIVATE "/W4")
    target_compile_options(pg_rgeo PRIVATE "/W4")
  endif()
endif()

#--------------------------------
# Build MobilityDB library
#--------------------------------

# MEOS
set(PROJECT_OBJECTS "$<TARGET_OBJECTS:temporal>")
set(PROJECT_OBJECTS ${PROJECT_OBJECTS} "$<TARGET_OBJECTS:geo>")
if(CBUFFER)
  message(STATUS "Including circular buffers")
  set(PROJECT_OBJECTS ${PROJECT_OBJECTS} "$<TARGET_OBJECTS:cbuffer>")
endif()
if(NPOINT)
  message(STATUS "Including network points")
  set(PROJECT_OBJECTS ${PROJECT_OBJECTS} "$<TARGET_OBJECTS:npoint>")
endif()
if(POSE)
  message(STATUS "Including geoposes")
  set(PROJECT_OBJECTS ${PROJECT_OBJECTS} "$<TARGET_OBJECTS:pose>")
endif()
if(RGEO)
  message(STATUS "Including rigid geometries")
  set(PROJECT_OBJECTS ${PROJECT_OBJECTS} "$<TARGET_OBJECTS:rgeo>")
endif()

# Build the library: PostGIS
set(PROJECT_OBJECTS ${PROJECT_OBJECTS} "$<TARGET_OBJECTS:liblwgeom>")
set(PROJECT_OBJECTS ${PROJECT_OBJECTS} "$<TARGET_OBJECTS:libpgcommon>")
set(PROJECT_OBJECTS ${PROJECT_OBJECTS} "$<TARGET_OBJECTS:ryu>")

# MobilityDB
set(PROJECT_OBJECTS ${PROJECT_OBJECTS} "$<TARGET_OBJECTS:pg_temporal>")
set(PROJECT_OBJECTS ${PROJECT_OBJECTS} "$<TARGET_OBJECTS:pg_geo>")
if(CBUFFER)
  set(PROJECT_OBJECTS ${PROJECT_OBJECTS} "$<TARGET_OBJECTS:pg_cbuffer>")
endif()
if(NPOINT)
  set(PROJECT_OBJECTS ${PROJECT_OBJECTS} "$<TARGET_OBJECTS:pg_npoint>")
endif()
if(POSE)
  set(PROJECT_OBJECTS ${PROJECT_OBJECTS} "$<TARGET_OBJECTS:pg_pose>")
endif()
if(RGEO)
  set(PROJECT_OBJECTS ${PROJECT_OBJECTS} "$<TARGET_OBJECTS:pg_rgeo>")
endif()

# Build the library
add_library(${MOBILITYDB_LIB_NAME} MODULE ${PROJECT_OBJECTS})
if(APPLE)
  If(${CMAKE_SYSTEM_PROCESSOR} MATCHES "arm")
    message(STATUS "Building for arm architecture")
    set_target_properties(${MOBILITYDB_LIB_NAME} PROPERTIES
    LINK_FLAGS "-Wl,-undefined,dynamic_lookup -bundle_loader /opt/homebrew/bin/postgres")
  else()
    message(STATUS "Building for x86 architecture")
    set_target_properties(${MOBILITYDB_LIB_NAME} PROPERTIES
    LINK_FLAGS "-Wl,-undefined,dynamic_lookup -bundle_loader /usr/local/bin/postgres")
  endif()
endif()

#--------------------------------
# Specify libraries to link
#--------------------------------

target_link_libraries(${MOBILITYDB_LIB_NAME} ${JSON-C_LIBRARIES})
target_link_libraries(${MOBILITYDB_LIB_NAME} ${LWGEOM_LIBRARIES})
target_link_libraries(${MOBILITYDB_LIB_NAME} ${GSL_LIBRARY})
target_link_libraries(${MOBILITYDB_LIB_NAME} ${GSL_CBLAS_LIBRARY})
target_link_libraries(${MOBILITYDB_LIB_NAME} ${GEOS_LIBRARY})
target_link_libraries(${MOBILITYDB_LIB_NAME} ${PROJ_LIBRARIES})
if(WIN32)
  message(STATUS "Adding PostGIS as a target link library")
  target_link_libraries(${MOBILITYDB_LIB_NAME} ${POSTGIS_LIBRARY})
endif()

#--------------------------------
# Belongs to MobilityDB
#--------------------------------

message(STATUS "Including SQL definitions and tests")
add_subdirectory(sql)
add_subdirectory(datagen)
add_subdirectory(test)
add_custom_target(mobilitydb_sql ALL DEPENDS ${CMAKE_BINARY_DIR}/${MOBILITYDB_EXTENSION_FILE})
add_custom_target(mobilitydb_datagen_sql ALL DEPENDS ${CMAKE_BINARY_DIR}/${MOBILITYDB_DATAGEN_EXTENSION_FILE})
add_custom_target(mobilitydb_control ALL DEPENDS ${CMAKE_BINARY_DIR}/mobilitydb.control)
# add_custom_target(datagen_sql ALL DEPENDS ${CMAKE_BINARY_DIR}/${MOBILITYDB_DATAGEN_EXTENSION_FILE})
# add_custom_target(datagen_control ALL DEPENDS ${CMAKE_BINARY_DIR}/datagen/mobilitydb_datagen.control)
install(
  FILES "${CMAKE_BINARY_DIR}/mobilitydb.control" "${CMAKE_BINARY_DIR}/${MOBILITYDB_EXTENSION_FILE}"
  DESTINATION "${POSTGRESQL_SHARE_DIR}/extension")
install(TARGETS ${MOBILITYDB_LIB_NAME} DESTINATION "${POSTGRESQL_DYNLIB_DIR}")
install(
  FILES "${CMAKE_BINARY_DIR}/mobilitydb_datagen.control" "${CMAKE_BINARY_DIR}/${MOBILITYDB_DATAGEN_EXTENSION_FILE}"
  DESTINATION "${POSTGRESQL_SHARE_DIR}/extension")

#-----------------------------------------------------------------------------
# The End
#-----------------------------------------------------------------------------

=== postgis/CMakeLists.txt ===
add_subdirectory("liblwgeom")
if(NOT MEOS)
  add_subdirectory("libpgcommon")
endif()
add_subdirectory("ryu")

=== meos/postgres/CMakeLists.txt ===
include_directories("common")
include_directories("lib")
include_directories("port")
include_directories("utils")

add_subdirectory("common")
add_subdirectory("port")
add_subdirectory("timezone")
add_subdirectory("utils")

=== meos/src/CMakeLists.txt ===
add_subdirectory(temporal)
add_subdirectory(geo)
if(CBUFFER)
  add_subdirectory(cbuffer)
endif()
if(NPOINT)
  add_subdirectory(npoint)
endif()
if(POSE)
  add_subdirectory(pose)
endif()
if(RGEO)
  add_subdirectory(rgeo)
endif()

=== mobilitydb/datagen/CMakeLists.txt ===
# Configure the control file
configure_file(mobilitydb_datagen.in.control ${CMAKE_BINARY_DIR}/mobilitydb_datagen.control)

# Configure the header template directly into the extension file
string(TIMESTAMP GENERATION_DATE "%Y-%m-%d %H:%M:%S")
configure_file(
    header.in.sql
    ${CMAKE_BINARY_DIR}/${MOBILITYDB_DATAGEN_EXTENSION_FILE}
    @ONLY
)

# Define list of source files
set(DATAGEN_FILES
  temporal/random_temporal.sql
  geo/random_tpoint.sql
  geo/random_tgeo.sql
  )
if(CBUFFER)
  list(APPEND DATAGEN_FILES cbuffer/random_tcbuffer.sql)
endif()
if(NPOINT)
  list(APPEND DATAGEN_FILES npoint/random_tnpoint.sql)
endif()
if(POSE)
  list(APPEND DATAGEN_FILES pose/random_tpose.sql)
endif()
if(RGEO)
  list(APPEND DATAGEN_FILES rgeo/random_trgeo.sql)
endif()

# Append each source file with license removed
foreach(f ${DATAGEN_FILES})
  # Read file as a list (one item per line)
  file(READ ${f} CURR_CONTENTS)
  # Append to extension file with small header line
  file(APPEND ${CMAKE_BINARY_DIR}/${MOBILITYDB_DATAGEN_EXTENSION_FILE}
    "\n-- Begin contents of ${f}\n\n${CURR_CONTENTS}\n")
endforeach()

=== mobilitydb/sql/CMakeLists.txt ===
set(MOBILITYDB_MODULE_PATHNAME "$libdir/lib${MOBILITYDB_LIB_NAME}")
set(extschema "@extschema@")

configure_file(mobilitydb.in.control ${CMAKE_BINARY_DIR}/mobilitydb.control)

macro(process_file f srcdir bindir)
  file(READ ${srcdir}/${f}.in.sql CURR_CONTENTS)

  if (${POSTGRESQL_VERSION_NUMBER} GREATER_EQUAL 130000)
    string(REPLACE "#if POSTGRESQL_VERSION_NUMBER >= 130000" "-- if POSTGRESQL_VERSION_NUMBER >= 130000" CURR_CONTENTS "${CURR_CONTENTS}")
    string(REPLACE "#endif //POSTGRESQL_VERSION_NUMBER >= 130000" "-- endif POSTGRESQL_VERSION_NUMBER >= 130000" CURR_CONTENTS "${CURR_CONTENTS}")

    string(REPLACE "#if POSTGRESQL_VERSION_NUMBER < 130000" "/* --if POSTGRESQL_VERSION_NUMBER < 130000" CURR_CONTENTS "${CURR_CONTENTS}")
    string(REPLACE "#endif //POSTGRESQL_VERSION_NUMBER < 130000" "-- endif POSTGRESQL_VERSION_NUMBER < 130000 */" CURR_CONTENTS "${CURR_CONTENTS}")
  else()
    string(REPLACE "#if POSTGRESQL_VERSION_NUMBER >= 130000" "/* -- if POSTGRESQL_VERSION_NUMBER >= 130000" CURR_CONTENTS "${CURR_CONTENTS}")
    string(REPLACE "#endif //POSTGRESQL_VERSION_NUMBER >= 130000" "-- endif POSTGRESQL_VERSION_NUMBER >= 130000 */" CURR_CONTENTS "${CURR_CONTENTS}")

    string(REPLACE "#if POSTGRESQL_VERSION_NUMBER < 130000" " -- if POSTGRESQL_VERSION_NUMBER >= 130000" CURR_CONTENTS "${CURR_CONTENTS}")
    string(REPLACE "#endif //POSTGRESQL_VERSION_NUMBER < 130000" "-- endif POSTGRESQL_VERSION_NUMBER >= 130000" CURR_CONTENTS "${CURR_CONTENTS}")
  endif()

  if (${POSTGRESQL_VERSION_NUMBER} GREATER_EQUAL 140000)
    string(REPLACE "#if POSTGRESQL_VERSION_NUMBER >= 140000" "-- if POSTGRESQL_VERSION_NUMBER >= 140000" CURR_CONTENTS "${CURR_CONTENTS}")
    string(REPLACE "#endif //POSTGRESQL_VERSION_NUMBER >= 140000" "-- endif POSTGRESQL_VERSION_NUMBER >= 140000" CURR_CONTENTS "${CURR_CONTENTS}")

    string(REPLACE "#if POSTGRESQL_VERSION_NUMBER < 140000" "/* --if POSTGRESQL_VERSION_NUMBER < 140000" CURR_CONTENTS "${CURR_CONTENTS}")
    string(REPLACE "#endif //POSTGRESQL_VERSION_NUMBER < 140000" "-- endif POSTGRESQL_VERSION_NUMBER < 140000 */" CURR_CONTENTS "${CURR_CONTENTS}")
  else()
    string(REPLACE "#if POSTGRESQL_VERSION_NUMBER >= 140000" "/* -- if POSTGRESQL_VERSION_NUMBER >= 140000" CURR_CONTENTS "${CURR_CONTENTS}")
    string(REPLACE "#endif //POSTGRESQL_VERSION_NUMBER >= 140000" "-- endif POSTGRESQL_VERSION_NUMBER >= 140000 */" CURR_CONTENTS "${CURR_CONTENTS}")

    string(REPLACE "#if POSTGRESQL_VERSION_NUMBER < 140000" " -- if POSTGRESQL_VERSION_NUMBER >= 140000" CURR_CONTENTS "${CURR_CONTENTS}")
    string(REPLACE "#endif //POSTGRESQL_VERSION_NUMBER < 140000" "-- endif POSTGRESQL_VERSION_NUMBER >= 140000" CURR_CONTENTS "${CURR_CONTENTS}")
  endif()

  if (${POSTGRESQL_VERSION_NUMBER} GREATER_EQUAL 160000)
    string(REPLACE "#if POSTGRESQL_VERSION_NUMBER >= 160000" "-- if POSTGRESQL_VERSION_NUMBER >= 160000" CURR_CONTENTS "${CURR_CONTENTS}")
    string(REPLACE "#endif //POSTGRESQL_VERSION_NUMBER >= 160000" "-- endif POSTGRESQL_VERSION_NUMBER >= 160000" CURR_CONTENTS "${CURR_CONTENTS}")

    string(REPLACE "#if POSTGRESQL_VERSION_NUMBER < 160000" "/* --if POSTGRESQL_VERSION_NUMBER < 160000" CURR_CONTENTS "${CURR_CONTENTS}")
    string(REPLACE "#endif //POSTGRESQL_VERSION_NUMBER < 160000" "-- endif POSTGRESQL_VERSION_NUMBER < 160000 */" CURR_CONTENTS "${CURR_CONTENTS}")
  else()
    string(REPLACE "#if POSTGRESQL_VERSION_NUMBER >= 160000" "/* -- if POSTGRESQL_VERSION_NUMBER >= 160000" CURR_CONTENTS "${CURR_CONTENTS}")
    string(REPLACE "#endif //POSTGRESQL_VERSION_NUMBER >= 160000" "-- endif POSTGRESQL_VERSION_NUMBER >= 160000 */" CURR_CONTENTS "${CURR_CONTENTS}")

    string(REPLACE "#if POSTGRESQL_VERSION_NUMBER < 160000" " -- if POSTGRESQL_VERSION_NUMBER >= 160000" CURR_CONTENTS "${CURR_CONTENTS}")
    string(REPLACE "#endif //POSTGRESQL_VERSION_NUMBER < 160000" "-- endif POSTGRESQL_VERSION_NUMBER >= 160000" CURR_CONTENTS "${CURR_CONTENTS}")
  endif()

  file(WRITE ${bindir}/${f}.sql.in "${CURR_CONTENTS}")
endmacro()

add_subdirectory(temporal)
add_subdirectory(geo)
if(CBUFFER)
  add_subdirectory(cbuffer)
endif()
if(NPOINT)
  add_subdirectory(npoint)
endif()
if(POSE)
  add_subdirectory(pose)
endif()
if(RGEO)
  add_subdirectory(rgeo)
endif()

list(SORT PROJECT_SQL_FILES)

add_custom_target(all_sql_files ALL
  DEPENDS ${PROJECT_SQL_FILES})

if (PROJECT_VERBOSE)
  message(STATUS "PROJECT_SQL_FILES=${PROJECT_SQL_FILES}")
endif()

foreach (f ${PROJECT_SQL_FILES})
  file(READ ${f} CURR_CONTENTS)
  file(APPEND ${CMAKE_CURRENT_BINARY_DIR}/${MOBILITYDB_EXTENSION_FILE}.in "${CURR_CONTENTS}")
endforeach()

configure_file(${CMAKE_CURRENT_BINARY_DIR}/${MOBILITYDB_EXTENSION_FILE}.in ${CMAKE_BINARY_DIR}/${MOBILITYDB_EXTENSION_FILE} COPYONLY)

# Set the library name extension according to the platform
if(WIN32)
  set(LIB_NAME_EXT ".dll")
else()
  set(LIB_NAME_EXT ".so")
endif()
message(STATUS "Library name extension: '${LIB_NAME_EXT}'")

file(READ "${CMAKE_BINARY_DIR}/${MOBILITYDB_EXTENSION_FILE}" sql_commands)
string(REPLACE "MODULE_PATHNAME" "${CMAKE_BINARY_DIR}/lib${MOBILITYDB_LIB_NAME}${LIB_NAME_EXT}" sql_commands "${sql_commands}")
message(STATUS "Substitution: ${CMAKE_BINARY_DIR}/lib${MOBILITYDB_LIB_NAME}${LIB_NAME_EXT}")
string(REPLACE "@extschema@" "public" sql_commands "${sql_commands}")

=== mobilitydb/test/CMakeLists.txt ===
add_subdirectory(scripts)
add_subdirectory(temporal)
add_subdirectory(geo)
if(CBUFFER)
  add_subdirectory(cbuffer)
endif()
if(NPOINT)
  add_subdirectory(npoint)
endif()
if(POSE)
  add_subdirectory(pose)
endif()
if(RGEO)
  add_subdirectory(rgeo)
endif()

=== postgis/liblwgeom/CMakeLists.txt ===
# if(NOT MEOS)
  # set(lwgeom_transform.c lwgeom_transform.c)
# endif()

add_library(liblwgeom OBJECT
  bytebuffer.c
  effectivearea.c
  gbox.c
  gserialized.c
  gserialized1.c
  gserialized2.c
  intervaltree.c
  lookup3.c
  lwalgorithm.c
  lwboundingcircle.c
  lwchaikins.c
  lwcircstring.c
  lwcollection.c
  lwcompound.c
  lwcurvepoly.c
  lwgeodetic.c
  lwgeodetic_measures.c
  lwgeodetic_tree.c
  lwgeom.c
  lwgeom_api.c
  lwgeom_debug.c
  lwgeom_geos.c
  lwgeom_geos_clean.c
  lwgeom_geos_cluster.c
  lwgeom_geos_node.c
  lwgeom_geos_split.c
  lwgeom_median.c
  # lwgeom_topo.c
  lwgeom_transform.c
  lwgeom_wrapx.c
  lwhomogenize.c
  lwin_encoded_polyline.c
  lwin_geojson.c
  lwin_twkb.c
  lwin_wkb.c
  lwin_wkt.c
  lwin_wkt_lex.c
  lwin_wkt_parse.c
  lwiterator.c
  lwkmeans.c
  lwline.c
  lwlinearreferencing.c
  lwmcurve.c
  lwmline.c
  lwmpoint.c
  lwmpoly.c
  lwmsurface.c
  lwmval.c
  lwout_encoded_polyline.c
  lwout_geojson.c
  lwout_gml.c
  lwout_kml.c
  lwout_svg.c
  lwout_twkb.c
  lwout_wkb.c
  lwout_wkt.c
  lwout_x3d.c
  lwpoint.c
  lwpoly.c
  lwprint.c
  lwpsurface.c
  lwrandom.c
  lwspheroid.c
  lwstroke.c
  lwtin.c
  lwtree.c
  lwtriangle.c
  lwunionfind.c
  lwutil.c
  measures.c
  measures3d.c
  optionlist.c
  ptarray.c
  stringlist.c
  stringbuffer.c
  varint.c
  )

set_property(TARGET liblwgeom PROPERTY C_VISIBILITY_PRESET hidden)
set_property(TARGET liblwgeom PROPERTY POSITION_INDEPENDENT_CODE ON)

=== debian/changelog ===
mobilitydb (1.3.0~alpha-3) unstable; urgency=medium

  [ Christoph Berg ]
  * Drop bogus postgresql-17-postgis-3 from test dependencies; the package
    itself already depends on postgis. (Closes: #1117729)

  [ Chris Lamb ]
  * mobilitydb/datagen/CMakeLists.txt: Use time zone UTC. (Closes: #1117742)

 -- Christoph Berg <myon@debian.org>  Fri, 10 Oct 2025 18:13:57 +0200

mobilitydb (1.3.0~alpha-2) unstable; urgency=medium

  * Upload for PostgreSQL 18. (Closes: #1117268)
  * Add ${postgresql:Breaks}.
  * debian/tests: Depend on postgresql-common-dev instead of 'make'.

 -- Christoph Berg <myon@debian.org>  Thu, 09 Oct 2025 10:56:01 +0200

mobilitydb (1.3.0~alpha-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 1.3.0~alpha.
  * Fix write past chunk end in ExprContext.

 -- Christoph Berg <myon@debian.org>  Fri, 19 Sep 2025 12:50:15 +0200

=== debian/control ===
Source: mobilitydb
Section: database
Priority: optional
Maintainer: Debian PostgreSQL Maintainers <team+postgresql@tracker.debian.org>
Uploaders:
 Bradford D. Boyle <bradford.d.boyle@gmail.com>,
Build-Depends:
 debhelper-compat (= 13),
 architecture-is-64-bit <!pkg.postgresql.32-bit>,
 architecture-is-little-endian,
 cmake,
 libgeos-dev,
 libgsl-dev,
 libjson-c-dev,
 libproj-dev,
 postgresql-18-postgis-3,
 postgresql-all <!nocheck>,
 postgresql-server-dev-all,
Standards-Version: 4.7.2
Homepage: https://mobilitydb.com/
Vcs-Browser: https://salsa.debian.org/postgresql/MobilityDB
Vcs-Git: https://salsa.debian.org/postgresql/MobilityDB.git

Package: postgresql-18-mobilitydb
Architecture: any
Depends:
 postgresql-18-postgis-3,
 ${misc:Depends},
 ${postgresql:Depends},
 ${shlibs:Depends},
Breaks:
 ${postgresql:Breaks},
Description: Open source geospatial trajectory data management & analysis platform
 MobilityDB is a database management system for moving object geospatial
 trajectories, such as GPS traces. It adds support for temporal and
 spatio-temporal objects to the PostgreSQL database and its spatial extension
 PostGIS.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_CPPFLAGS_MAINT_APPEND := -DNDEBUG

%:
	dh $@ --with pgxs

override_dh_auto_configure:
	+pg_buildext run dh_auto_configure -Bbuild-%v -- -DPOSTGRESQL_PG_CONFIG=/usr/lib/postgresql/%v/bin/pg_config

override_dh_installdocs:
	dh_installdocs --all README.*

override_dh_pgxs_test:
	# nothing to do here, see debian/tests/* instead

=== debian/tests/control ===
Depends:
 cmake,
 g++,
 libgeos-dev,
 libgsl-dev,
 libjson-c-dev,
 libproj-dev,
 postgresql-common-dev,
 xz-utils,
 @,
Tests:
 installcheck,
Restrictions:
 allow-stderr,

=== debian/watch ===
version=4
opts=uversionmangle=s/-alpha/~alpha/;s/-beta/~beta/;s/rc/~rc/ \
https://github.com/MobilityDB/MobilityDB/tags .*/v(.*).tar.gz
